drm/rockchip: Don't change hdmi reference clock rate
[drm/drm-misc.git] / tools / perf / tests / shell / stat+std_output.sh
blobcbf2894b2c846a0495e56aa7728366c91cfe85cb
1 #!/bin/bash
2 # perf stat STD output linter
3 # SPDX-License-Identifier: GPL-2.0
4 # Tests various perf stat STD output commands for
5 # default event and metricgroup
7 set -e
9 # shellcheck source=lib/stat_output.sh
10 . "$(dirname $0)"/lib/stat_output.sh
12 stat_output=$(mktemp /tmp/__perf_test.stat_output.std.XXXXX)
14 event_name=(cpu-clock task-clock context-switches cpu-migrations page-faults stalled-cycles-frontend stalled-cycles-backend cycles instructions branches branch-misses)
15 event_metric=("CPUs utilized" "CPUs utilized" "/sec" "/sec" "/sec" "frontend cycles idle" "backend cycles idle" "GHz" "insn per cycle" "/sec" "of all branches")
16 skip_metric=("stalled cycles per insn" "tma_" "retiring" "frontend_bound" "bad_speculation" "backend_bound")
18 cleanup() {
19 rm -f "${stat_output}"
21 trap - EXIT TERM INT
24 trap_cleanup() {
25 cleanup
26 exit 1
28 trap trap_cleanup EXIT TERM INT
30 function commachecker()
32 local prefix=1
34 case "$1"
35 in "--interval") prefix=2
36 ;; "--per-thread") prefix=2
37 ;; "--system-wide-no-aggr") prefix=2
38 ;; "--per-core") prefix=3
39 ;; "--per-socket") prefix=3
40 ;; "--per-node") prefix=3
41 ;; "--per-die") prefix=3
42 ;; "--per-cache") prefix=3
43 ;; "--per-cluster") prefix=3
44 esac
46 while read line
48 # Ignore initial "started on" comment.
49 x=${line:0:1}
50 [ "$x" = "#" ] && continue
51 # Ignore initial blank line.
52 [ "$line" = "" ] && continue
53 # Ignore "Performance counter stats"
54 x=${line:0:25}
55 [ "$x" = "Performance counter stats" ] && continue
56 # Ignore "seconds time elapsed" and break
57 [[ "$line" == *"time elapsed"* ]] && break
59 main_body=$(echo $line | cut -d' ' -f$prefix-)
60 x=${main_body%#*}
61 [ "$x" = "" ] && continue
63 # Skip metrics without event name
64 y=${main_body#*#}
65 for i in "${!skip_metric[@]}"; do
66 [[ "$y" == *"${skip_metric[$i]}"* ]] && break
67 done
68 [[ "$y" == *"${skip_metric[$i]}"* ]] && continue
70 # Check default event
71 for i in "${!event_name[@]}"; do
72 [[ "$x" == *"${event_name[$i]}"* ]] && break
73 done
75 [[ ! "$x" == *"${event_name[$i]}"* ]] && {
76 echo "Unknown event name in $line" 1>&2
77 exit 1;
80 # Check event metric if it exists
81 [[ ! "$main_body" == *"#"* ]] && continue
82 [[ ! "$main_body" == *"${event_metric[$i]}"* ]] && {
83 echo "wrong event metric. expected ${event_metric[$i]} in $line" 1>&2
84 exit 1;
86 done < "${stat_output}"
87 return 0
90 perf_cmd="-o ${stat_output}"
92 skip_test=$(check_for_topology)
93 check_no_args "STD" "$perf_cmd"
94 check_system_wide "STD" "$perf_cmd"
95 check_interval "STD" "$perf_cmd"
96 check_per_thread "STD" "$perf_cmd"
97 check_per_node "STD" "$perf_cmd"
98 if [ $skip_test -ne 1 ]
99 then
100 check_system_wide_no_aggr "STD" "$perf_cmd"
101 check_per_core "STD" "$perf_cmd"
102 check_per_cache_instance "STD" "$perf_cmd"
103 check_per_cluster "STD" "$perf_cmd"
104 check_per_die "STD" "$perf_cmd"
105 check_per_socket "STD" "$perf_cmd"
106 else
107 echo "[Skip] Skipping tests for system_wide_no_aggr, per_core, per_die and per_socket since socket id exposed via topology is invalid"
109 cleanup
110 exit 0